"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (session) => { var _BetterSqlite3SessionStore_instances, _BetterSqlite3SessionStore_validateOptions, _BetterSqlite3SessionStore_prepareStatements, _BetterSqlite3SessionStore_createTable, _BetterSqlite3SessionStore_startExpirationInterval, _a; return _a = class BetterSqlite3SessionStore extends session.Store {
        /* The only public API */
        constructor(options) {
            super();
            _BetterSqlite3SessionStore_instances.add(this);
            this.conn = options.connection;
            this.ttl = options.ttl;
            this.tableName = options.tableName || "sessions";
            __classPrivateFieldGet(this, _BetterSqlite3SessionStore_instances, "m", _BetterSqlite3SessionStore_validateOptions).call(this);
            __classPrivateFieldGet(this, _BetterSqlite3SessionStore_instances, "m", _BetterSqlite3SessionStore_createTable).call(this);
            // prepare the statements ahead of time thereby letting the database
            // optimize query planning, among other things
            this.statements = __classPrivateFieldGet(this, _BetterSqlite3SessionStore_instances, "m", _BetterSqlite3SessionStore_prepareStatements).call(this);
            // start a `setInterval()` to delete expired sessions
            __classPrivateFieldGet(this, _BetterSqlite3SessionStore_instances, "m", _BetterSqlite3SessionStore_startExpirationInterval).call(this);
        }
        /* The express-session contract */
        set(sid, session, callback = () => { }) {
            var _a;
            const age = ((_a = session.cookie) === null || _a === void 0 ? void 0 : _a.maxAge) || 0;
            const expires = Date.now() + age;
            const data = JSON.stringify(session);
            try {
                const result = this.statements.set.run(sid, expires, data);
                return callback(null, result);
            }
            catch (err) {
                return callback(err, null);
            }
        }
        get(sid, callback = () => { }) {
            var _a;
            try {
                const jsonString = ((_a = this.statements.get.get(sid)) === null || _a === void 0 ? void 0 : _a.data) || "{}";
                const result = JSON.parse(jsonString);
                return callback(null, result);
            }
            catch (e) {
                return callback(e, null);
            }
        }
        destroy(sid, callback = () => { }) {
            try {
                const result = this.statements.destroy.run(sid);
                return callback(null, result);
            }
            catch (e) {
                return callback(e, null);
            }
        }
        length(callback) {
            try {
                const result = this.statements.length.get();
                return callback(null, result === null || result === void 0 ? void 0 : result.count);
            }
            catch (e) {
                return callback(e, Infinity);
            }
        }
        clear(callback = () => { }) {
            try {
                const result = this.statements.clear.run();
                return callback(null, result);
            }
            catch (e) {
                return callback(e, null);
            }
        }
        touch(sid, session, callback = () => { }) {
            var _a;
            const age = ((_a = session.cookie) === null || _a === void 0 ? void 0 : _a.maxAge) || 0;
            const expires = Date.now() + age;
            try {
                const result = this.statements.touch.run(expires, sid);
                return callback(null, result);
            }
            catch (e) {
                return callback(e, null);
            }
        }
        all(callback) {
            try {
                const result = this.statements.all.all().map(row => JSON.parse(row.data));
                return callback(null, result);
            }
            catch (e) {
                return callback(e, []);
            }
        }
    },
    _BetterSqlite3SessionStore_instances = new WeakSet(),
    _BetterSqlite3SessionStore_validateOptions = function _BetterSqlite3SessionStore_validateOptions() {
        if (!this.conn) {
            throw new Error("No connection provided. Please provide a better-sqlite3 database connection");
        }
        if (!this.ttl) {
            throw new Error("No TTL provided. This is the time after which the session will be deleted");
        }
    },
    _BetterSqlite3SessionStore_prepareStatements = function _BetterSqlite3SessionStore_prepareStatements() {
        return {
            expiry: this.conn.prepare(`DELETE FROM ${this.tableName} WHERE expires < ?`),
            set: this.conn.prepare(`INSERT OR REPLACE INTO ${this.tableName} VALUES (?, ?, ?)`),
            get: this.conn.prepare(`SELECT data FROM ${this.tableName} WHERE sid = ? AND datetime('now') < expires`),
            destroy: this.conn.prepare(`DELETE FROM ${this.tableName} WHERE sid = ?`),
            length: this.conn.prepare(`SELECT COUNT(*) AS length FROM ${this.tableName}`),
            clear: this.conn.prepare(`DELETE FROM ${this.tableName}`),
            touch: this.conn.prepare(`UPDATE ${this.tableName} SET expires = ? WHERE sid = ?`),
            all: this.conn.prepare(`SELECT data FROM ${this.tableName}`),
        };
    },
    _BetterSqlite3SessionStore_createTable = function _BetterSqlite3SessionStore_createTable() {
        this.conn.exec(`CREATE TABLE
                IF NOT EXISTS
                    ${this.tableName} (
                        sid TEXT PRIMARY KEY,
                        expires TIMESTAMP NOT NULL,
                        data JSON NOT NULL
                    );`);
    },
    _BetterSqlite3SessionStore_startExpirationInterval = function _BetterSqlite3SessionStore_startExpirationInterval() {
        setInterval(() => {
            this.statements.expiry.run(Date.now());
        }, this.ttl);
    },
    _a; };
//# sourceMappingURL=index.js.map